//-------------------------------------------------------------
// Mode 0
//
// Find all the words that have at least 24 letters.  
//
// You don't have to do anything for this one -- the code is
// provided as an example.
//
// Note that most of the puzzles will follow a similar pattern:
// declare an empty array of Strings.  Then iterate over the global
// array of words, finding all the ones that satisfy the given puzzle.
// Append all those matching words to the array.  Then, at the end,
// return the array.  You'll end up re-using this structure a lot.

String[] getWords_0()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    if ( words[idx].length() >= 24 ) {
      ret = append( ret, words[idx] );
    }
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 1
//
// Find all words that start with "th" and end with "th".

String[] getWords_1() 
{
  String[] ret = {""};

  for ( int idx = 0; idx < words.length; ++idx ) {
// your code here
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 2
//
// Find all words that contain all the vowels (a, e, i, o, u)
//    at least once.

String[] getWords_2()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
// your code here
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 3
//
// Find all words with six or more letters, in which all the
// letters are in strict alphabetical order (no repeated letters
// allowed!).  Example: "almost".

String[] getWords_3()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
 // your code here
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 4
//
// Find all words with 14 or more letters in which no letter is
// repeated anywhere in the word.  So, for example, "undiscoverable"
// Doesn't work because it has two "e"s in it, but "undiscoverably"
// is fine.

String[] getWords_4()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
 // your code here
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 5
//
// Find all eight-letter words where, if you move the first two
// letters of the word to the end, the result is still a valid
// eight-letter word.  Example: "bypasser", which becomes 
// "passerby" when you move the "by" from the start to the end
// of the word.

String[] getWords_5()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
 // your code here
  }
  return ret;
}

//-------------------------------------------------------------
// Mode 6
//
// Find all words in which the vowels "a", "e", "i", "o", 
// "u" and "y" appear in that order in the word, with no
// other vowels.  Example: "facetiously".

// This regular expression is provided for you.  It determines
// whether a complete word contains the vowels a,e,i,o,u,y in order,
// with no other vowels in between.  You can use it as an argument
// to the built-in function match().  If that function returns a 
// non-null array, that tells you that the pattern was found, and
// the word is one of the ones you want.
//
// Here's a breakdown of the pattern:
//  * The initial "^" means that the pattern has to start at the start of
//    the line of text.
//  * The "[^aeiouy]" matches any letter that _isn't_ one of a, e, i, o, u, y.
//  * The "*" means to match any number of occurrences of something.  So
//    "[^aeiouy]*" is any run of consecutive consonants, possibly of length 0.
//  * The embedded "a", "e", "i", "o", "u" and "y" match precisely those letters.
//  * The final "$" forces the match to go right to the end of the line.
String aeiouy_pattern = "^[^aeiouy]*a[^aeiouy]*e[^aeiouy]*i[^aeiouy]*o[^aeiouy]*u[^aeiouy]*y[^aeiouy]*$";

String[] getWords_6()
{
  String[] ret = {};

  for (int idx = 0; idx < words.length; ++idx) {
// your code here
  }
  return ret;
}
